<template>
<v-app></v-app>
</template>

<script>
import axios from 'axios';
import Swal from 'sweetalert2';
import Cookies from 'js-cookie';
import {
    jwtDecode
} from "jwt-decode";

export default {
    data() {
        return {
            dropdown: false,
            items: ['จัดการเมนู', 'จัดการคำสั่งซื้อ'],
            token: Cookies.get('token'),
            role: "",
            products: [],
            currentPage: 1,
            itemsPerPage: 50,
            firstName: '',
            loginId: '',
        };
    },
    created() {
        this.fetchProducts();
        this.getuser(); // Call getuser to retrieve user information
    },
    computed: {
        totalPages() {
            return Math.ceil(this.products.length / this.itemsPerPage);
        },
        paginatedProducts() {
            const startIndex = (this.currentPage - 1) * this.itemsPerPage;
            const endIndex = startIndex + this.itemsPerPage;
            return this.products.slice(startIndex, endIndex);
        },
    },
    methods: {
        navigateToPage(index) {
            let route = '';
            if (index === 0) {
                route = '/cartshop';
            } else if (index === 1) {
                route = '/ordershop';
            }
            this.$router.push(route);
            this.dropdown = false;
        },
        async fetchProducts() {
            try {
                const response = await axios.get('http://192.168.73.121:3000/products', {
                    headers: {
                        Authorization: `Bearer ${this.token}`
                    }
                });
                this.products = response.data.data.map(product => ({
                    ...product,
                    quantity: 1
                }));
            } catch (error) {
                console.error('Error fetching products:', error);
                Swal.fire({
                    title: "Error fetching products",
                    icon: "error",
                    showConfirmButton: false,
                    timer: 1500
                });
            }
        },
        increaseQuantity(product) {
            if (product.quantity < product.amount) {
                product.quantity++;
            } else {
                Swal.fire({
                    title: "Cannot exceed available stock",
                    icon: "error",
                    showConfirmButton: false,
                    timer: 1500
                });
            }
        },
        decreaseQuantity(product) {
            if (product.quantity > 1) {
                product.quantity--;
            }
        },
        async addToCart(product) {
            try {
                if (product.quantity > product.amount) {
                    Swal.fire({
                        title: "Quantity exceeds available stock",
                        icon: "error",
                        showConfirmButton: false,
                        timer: 1500
                    });
                    return;
                }

                await axios.post(`http://192.168.73.121:3000/cart/${this.loginId}/add`, {
                    productId: product._id,
                    quantity: product.quantity
                }, {
                    headers: {
                        Authorization: `Bearer ${this.token}`
                    }
                });
                this.$emit('update-cart');
                Swal.fire({
                    title: "Item added to cart successfully",
                    icon: "success",
                    showConfirmButton: false,
                    timer: 1500
                });
            } catch (error) {
                console.error('Error adding to cart:', error);
                Swal.fire({
                    title: "Error adding to cart",
                    icon: "error",
                    showConfirmButton: false,
                    timer: 1500
                });
            }
        },
        goToCartPage() {
            this.$router.push('/CartShop');
        },
        async getuser() {
            if (this.token) {
                try {
                    const decoded = jwtDecode(this.token);
                    this.firstName = decoded.firstName;
                    this.loginId = decoded._id;
                    console.log(this.firstName);
                    console.log(this.loginId);
                } catch (error) {
                    Swal.fire({
                        position: "center",
                        icon: "error",
                        title: "Session Expired",
                        showConfirmButton: false,
                        timer: 3000
                    });
                    this.$router.push('/Homepage');
                }
            } else {
                Swal.fire({
                    position: "center",
                    icon: "error",
                    title: "Time Out",
                    showConfirmButton: false,
                    timer: 3000
                });
                this.$router.push('/Homepage');
            }
        },
    }
};
</script>

<style>
@import url("https://fonts.googleapis.com/css2?family=Prompt:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap");

.font {
    font-family: "Prompt", sans-serif;
}

.tab-menu {
    display: flex;
    justify-content: center;
}
</style>
